免费注册 查看新帖 |

Chinaunix

  平台 论坛 博客 文库
最近访问板块 发新帖
查看: 2066 | 回复: 1

CentOS 下管理自定义 PHP 计划任务代码的守护进程脚本 [复制链接]

论坛徽章:
0
发表于 2012-02-17 15:49 |显示全部楼层

CentOS 下管理自定义 PHP 计划任务代码的守护进程脚本



php脚本.
  1. from http://micate.me/centos-php-crontab-script-manage-shell.note
  2. « javascript dialog 对话框的问题总结MySQL的表分区 »CentOS 下管理自定义 PHP 计划任务代码的守护进程脚本
  3. Version: 2011-12-05   Print Published at 02:45 in 技术. 2 Comments
  4. Tags: centos, php, 计划任务.
复制代码
有需求想实现比 crontab 更频繁一点的计划任务,折腾一通之后,写下这个脚本,目前在 CentOS 6 下测试没有问题:

ChangeLog
2011.12.05
添加 PHP 执行用户设置,用以适应如在计划任务中执行生成文件操作时的文件权限问题,未完成;
2011.12.02
建立文档;
  1. #!/bin/bash
  2. #
  3. # chkconfig: 35 90 12
  4. # description: Queue Daemon
  5. #

  6. # Get function from functions library
  7. . /etc/init.d/functions

  8. # PHP 访问路径,如果 PHP 是编译安装则需要修改
  9. php_path="/usr/bin/php"
复制代码
# PHP 执行用户名
# Nginx 环境下常见为 nginx 或 www,
# Apapche 环境下常见为 php 或 apache
# 用在某些时候需要在计划任务中生成文件时文件权限不正确的问题
php_user=nginx

# 要管理的 PHP 计划任务脚本
# 该目录下必须都是 PHP 可执行代码文件
queue_path="/www/micate.dev/crontab/"

# PHP 计划任务执行日志保存路径
# 默认以 脚本名.log 的方式存储
log_path="/var/log/queue/"

# 守护进程 PID 路径
pid_path="/var/run/queued.pid"

# 守护进程在启动退出时的提示名称
  1. prog="Queued"

  2. # Start the service
  3. start() {
  4. echo -n $"Starting $prog: "

  5. if [ -f $pid_path ]; then
  6. echo -n "pid "$pid_path" exists."
  7. failure
  8. echo
  9. return 0
  10. fi

  11. if [ ! -d $log_path ]; then
  12. mkdir -p $log_path
  13. fi

  14. queues=$(ls $queue_path)
  15. for queue in $queues
  16. do
  17. # TODO sudo -u $php_user
  18. nohup $php_path $queue_path$queue 1>>$log_path$queue.log 2>/dev/null &
  19. retval=$?
  20. if [ ! $retval -eq 0 ]; then
  21. echo -n $queue" init failed."
  22. failure
  23. echo
  24. return 0
  25. fi
  26. echo $! >> $pid_path
  27. done

  28. success
  29. echo
  30. return $retval
  31. }

  32. # Stop the service
  33. stop() {
  34. echo -n $"Stopping $prog: "

  35. if [ ! -f $pid_path ]; then
  36.                 echo -n "pid "$pid_path" not exists."
  37.                 failure
  38.                 echo
  39.                 return 0
  40.         fi

  41. queues=$(cat $pid_path)
  42. for queue in $queues
  43. do
  44. kill -9 $queue 1>/dev/null 2>&1
  45. retval=$?
  46.                 if [ ! $retval -eq 0 ]; then
  47.                         echo -n $queue" stop failed."
  48.                         failure
  49.                         echo
  50.                         return 0
  51.                 fi
  52. done

  53. rm -f $pid_path

  54. success
  55. echo
  56. return $retval
  57. }

  58. ### main logic ###
  59. case "$1" in
  60.   start)
  61. start
  62. ;;
  63.   stop)
  64. stop
  65. ;;
  66.   restart)
  67. stop
  68. start
  69. ;;
  70.   *)
  71. echo $"Usage: $0 {start|stop|restart}"
  72. exit 1
  73. esac

  74. exit 0
  75. 使用方法
  76. 1.根据实际情况,按照上面的配置提示,修改相应配置,并保存为 /etc/init.d/queued(建议以这样的方式命名,注意路径必须是 /etc/init.d/)
  77. 2.在 Shell 里面执行:

  78. # 为守护进程脚本增加执行权限
  79. chmod +x /etc/init.d/queued
  80. # 设置开机启动
  81. chkconfig queued on守护进程设置完成。
复制代码
3.在上面配置的目录中添加测试 PHP 计划任务脚本,如 hello.php:
  1. <?php
  2. // 注意,推荐使用死循环的方式
  3. // 这个守护进程脚本也是以这个思路来写的
  4. while (true)
  5. {
  6.     // 做点事情

  7.     // 注意,这里的输出会记录到日志文件里面,可以输出些有用的信息来帮助排除问题
  8.     echo "hello from queued.\n";

  9.     // 延迟时间,建议用秒级别的,usleep ... 你确定么?
  10.     sleep(20);
  11. }4.好了,来运行看看:

  12. /etc/init.d/queued start查看下日志目录:

  13. less /var/log/queue/hello.php.log收工。

  14. 其他的,比如:

  15. # 停止所有计划任务
  16. /etc/init.d/queued stop

  17. # 重新启动守护进程脚本
  18. /etc/init.d/queued restart注意事项
  19. 1.由于是基于死循环的方式实现,如果代码里面有引入基础文件后的死循环操作,那依赖基础文件中的变量的代码部分,要注意调整,举例来说:

  20. <?php
  21. define('START_TIME', microtime(true));

  22. // 假如这个文件里面定义了 TIME 常量,
  23. // 以备后面的代码获取当前时间用
  24. //(避免一次请求中多次调用 time() 函数带来的性能损失)
  25. require '../init.php';

  26. $interval = value(config('mail'), 'interval', 20);
  27. $interval_size = value(config('mail'), 'interval_size', 50);
  28. while (true)
  29. {
  30.     $queue = & factory::queue('mail');

  31.     // 这里的定时循环,用到了 TIME 常量
  32.     // 比如记录执行时间,甚至用 TIME 常量做查询条件
  33.     echo $queue->interval($interval_size);
  34.     sleep($interval);
复制代码
}看了上面的注释,问题就比较明显了。
当以普通用户请求过去时,由于是正常流程,每次请求发起后,TIME 都会重新赋予正确的当前时间;
但当使用死循环后,以后的每次 interval 用到的时间都会是 该计划任务脚本启动时间。
这就是问题,需要注意和调整。

2.修改和添加计划任务后,需要重新启动守护进程,方法上面已经介绍了,restart 就可以。
3.担心日志过多?设置下日志自动滚动切割吧:

# 在 /etc/logrotate.d/ 目录下建立 queued 文件
vim /etc/logrotate.d/queued

# 输入如下的信息,路径之类的要和你自己设置的保持一致
/
  1. var/log/queue/*log {
  2.     daily
  3.     rotate 10
  4.     missingok
  5.     notifempty
  6.     sharedscripts
  7.     compress
  8.     postrotate
  9.         /etc/init.d/queued restart > /dev/null 2>/dev/null || true
  10.     endscript
复制代码
}保存文件,完成。
这样,每天日志会自动滚动切割,最多保留 10 个日志文件(未验证这个步骤... 如有问题请反馈)。

4.进程崩溃、服务器断电...导致守护进程起不来或停不了了?
直接 ps -ef | grep *** 关键词,看是否有在运行的 PHP 计划任务代码,kill 掉,然后删除 pid 文件,重新启动即可。
更多...
其实 crontab 也有对应的解决方法:

# 打开 crontab 编辑界面
crontab -e

# 输入类似的设置
* * * * * /bin/date
* * * * * sleep 20; /bin/date
* * * * * sleep 40; /bin/date思想就是... 同时添加多个任务,然后每个之前以适当的延时隔离开,就是说每分钟会有 N 个程序被触发,但会逐个延迟执行,也是个不错的解决思路。


相关文章:
■在 Windows 主机上定时备份远程 VPS(CentOS) 数据
■在 CentOS 6 环境中配置 nginx + php-fpm + mysql
■Schtasks 计划任务参数详解
■关闭 selinux 和使其立即生效
■CentOS 5 修改系统时区

2 Responses to “CentOS 下管理自定义 PHP 计划任务代码的守护进程脚本”
Feed for this Entry Trackback Address

--------------------------------------------------------------------------------

蛮-com
2011/12/05 at 13:21
死循环的php-fpm会不会有问题啊啊啊?

Reply
龙猫
2011/12/05 at 16:27
@杨哥(http://www.yanghengfei.com/) 提到,死循环中的 PHP 是不会释放变量的内存的,一直循环下去,如果代码上稍不注意,有可能... 内存爆掉。

但这个跟 PHP-FPM 没关系吧... 调用的是 /usr/bin/ 下的 php,PHP-FPM 在 /usr/sbin/ 下,和 Nginx 木有交互哦。

准备来个 V2,用 shell 死循环代替 PHP 死循环,但我觉得问题会是... 循环时间过短导致下次循环开始时,上次的还没执行完。判断进程名称?写出来再说吧。

Reply

论坛徽章:
0
发表于 2012-02-17 22:07 |显示全部楼层
谢谢分享
您需要登录后才可以回帖 登录 | 注册

本版积分规则 发表回复

  

北京盛拓优讯信息技术有限公司. 版权所有 京ICP备16024965号-6 北京市公安局海淀分局网监中心备案编号:11010802020122 niuxiaotong@pcpop.com 17352615567
未成年举报专区
中国互联网协会会员  联系我们:huangweiwei@itpub.net
感谢所有关心和支持过ChinaUnix的朋友们 转载本站内容请注明原作者名及出处

清除 Cookies - ChinaUnix - Archiver - WAP - TOP